/*****************************************************
This program was produced by the
CodeWizardAVR V1.25.3 Standard
Automatic Program Generator
 Copyright 1998-2007 Pavel Haiduc, HP InfoTech s.r.l.
http://www.hpinfotech.com

Project : 
Version : 
Date    : 19.10.2008
Author  : Dmitry Eljuseev, RA1AHC                            


Chip type           : ATtiny13
Clock frequency     : 9,600000 MHz
Memory model        : Tiny
External SRAM size  : 0
Data Stack size     : 16
*****************************************************/

// CodeVisionAVR C Compiler
// (C) 1998-2003 Pavel Haiduc, HP InfoTech S.R.L.

// I/O registers definitions for the ATtiny13


#pragma used+
sfrb ADCSRB=0x03;
sfrb ADCL=0x04;
sfrb ADCH=0x05;
sfrw ADCW=0x04; // 16 bit access
sfrb ADCSRA=0x06;
sfrb ADMUX=0x07;
sfrb ACSR=0x08;
sfrb DIDR0=0x14;
sfrb PCMSK=0x15;
sfrb PINB=0x16;
sfrb DDRB=0x17;
sfrb PORTB=0x18;
sfrb EECR=0x1c;
sfrb EEDR=0x1d;
sfrb EEAR=0x1e;
sfrb WDTCR=0x21;
sfrb CLKPR=0x26;
sfrb GTCCR=0x28;
sfrb OCR0B=0x29;
sfrb DWDR=0x2e;
sfrb TCCR0A=0x2f;
sfrb OSCCAL=0x31;
sfrb TCNT0=0x32;
sfrb TCCR0B=0x33;
sfrb MCUSR=0x34;
sfrb MCUCR=0x35;
sfrb OCR0A=0x36;
sfrb SPMCSR=0x37;
sfrb TIFR0=0x38;
sfrb TIMSK0=0x39;
sfrb GIFR=0x3a;
sfrb GIMSK=0x3b;
sfrb SPL=0x3d;
sfrb SREG=0x3f;
#pragma used-

// Interrupt vectors definitions



// CodeVisionAVR C Compiler
// (C) 1998-2000 Pavel Haiduc, HP InfoTech S.R.L.


#pragma used+

void delay_us(unsigned int n);
void delay_ms(unsigned int n);

#pragma used-


// Port out:
// Port LED:


// Morze length

const unsigned char phrase[] = "CQ CQ DE BEACON 1/2W FROM SPB RU 60N 30E SEND REPORTS TO BEACONSPB  GMAIL COM.";


// Declare your global variables here
// 0 - "."
// 1 - "-"   
// 2 - pause        
// 3 - long pause        
// 5 - null

const unsigned char symbols[] = { 
                                        1,0,0,1,0, 1,1,1,1,1, 0,1,1,1,1, 0,0,1,1,1, 0,0,0,1,1, 0,0,0,0,1, 0,0,0,0,0, 1,0,0,0,0, 1,1,0,0,0, 1,1,1,0,0, 1,1,1,1,0,    // '/',0,1-9
                                        2,2,2,5,5       , 2,2,2,5,5       , 2,2,2,5,5       , 2,2,2,5,5       , 2,2,2,5,5       , 2,2,2,5,5       , 2,2,2,5,5       ,                     // :;<=>?@
                                        0,1,5,5,5, 1,0,0,0,5, 1,0,1,0,5, 1,0,0,5,5, 0,5,5,5,5, 0,0,1,0,5, 1,1,0,5,5, 0,0,0,0,5, 0,0,5,5,5, 0,1,1,1,5, 1,0,1,5,5, 0,1,0,0,5, 1,1,5,5,5, 1,0,5,5,5, 1,1,1,5,5, 0,1,1,0,5, 1,1,0,1,5, 0,1,0,5,5, 0,0,0,5,5, 1,5,5,5,5, 0,0,1,5,5, 0,0,0,1,5, 0,1,1,5,5, 1,0,0,1,5, 1,0,1,1,5, 1,1,0,0,5 
                                };

void morze_out(flash unsigned char *pData)
{                       
        unsigned char p, p1;
        for(p=0; p<128; p++)
        {                       
                unsigned char symb = pData[p];
                if (symb == '.') break;
                                       
                if (symb == ' ') symb = '='; //      
                if (symb >= '/' && symb <= 'Z')
                {                
                        unsigned int symb_code  = symb - '/';
                        unsigned int symb_index = 5*symb_code;    
                        if (symb_index >= sizeof(symbols)) continue;  
                                        
                        for(p1=0; p1<5; p1++)
                        {
                               if (symbols[symb_index + p1] == 0) // "."
                               {                     
                                       PORTB.0   = 1;
                                       delay_ms(80);
                                       PORTB.0   = 0;
                                       delay_ms(80);
                               } else
                               if (symbols[symb_index + p1] == 1) // "-"
                               {                     
                                       PORTB.0   = 1;
                                       delay_ms(3*80);
                                       PORTB.0   = 0;
                                       delay_ms(80);
                               } else
                               if (symbols[symb_index + p1] == 2) // "pause"
                               {                     
                                       delay_ms(80);
                               } 
                        }                                                          
                        
                        delay_ms(3*80  );
                } 
        }
}

void main(void)
{
        // Input/Output Ports initialization
        // Port B initialization
        // Func5=Out Func4=Out Func3=Out Func2=Out Func1=Out Func0=Out 
        // State5=0 State4=0 State3=0 State2=0 State1=0 State0=0 
        PORTB=0x00;
        DDRB=0x3F;
        
        // Timer/Counter 0 initialization
        // Clock source: System Clock
        // Clock value: Timer 0 Stopped
        // Mode: Normal top=FFh
        // OC0A output: Disconnected
        // OC0B output: Disconnected
        TCCR0A=0x00;
        TCCR0B=0x00;
        TCNT0=0x00;
        OCR0A=0x00;
        OCR0B=0x00;
        
        // External Interrupt(s) initialization
        // INT0: Off
        // Interrupt on any change on pins PCINT0-5: Off
        GIMSK=0x00;
        MCUCR=0x00;
        
        // Timer/Counter 0 Interrupt(s) initialization
        TIMSK0=0x00;
        
        // Analog Comparator initialization
        // Analog Comparator: Off
        ACSR=0x80;
        ADCSRB=0x00;
        
        while (1)
        {                         
                unsigned char p;
                for(p=0; p<3; p++)
                {
                        morze_out(phrase);
        
                        PORTB.1    = 1;
                        delay_ms(500);
                        PORTB.1    = 0;
                }
                
                delay_ms(12000);             
        
        };
}
